function lsd.get_module_fov()
	local fov = lsd.get_module_prototype('fov')
	
	fov.delay = 50

	--fov.a_rng = PseudoPerlin:create_rng(0.02, 0.4, 3)
	fov.rng = PseudoPerlin:create_rng(0.003, 0.4, 3)
	
	fov.intro = true
	fov.orig = Game.GetCVar('fov')
	fov.invert_orig = fov.orig
	fov.current = fov.orig
	fov.desired = fov.orig
	fov.min = fov.orig - 20
	fov.max = fov.orig + 40
	fov.tmp = 0

	fov.trans_start = fov.orig
	fov.trans_delta = 0.025
	
	fov.periodic_invert = true
	fov.inverted = false
	fov.invert_delay = 5000
	fov.invert_count = 0

	function fov:update_val()
		local a = self.rng:get()
		self.desired = (self.max-self.min)*a + self.min

		-- chance of inverting the view
		if self.periodic_invert and (self.invert_count * self.delay > self.invert_delay) then
			math.randomseed(gkmisc.GetGameTime())
			fov.invert_delay = math.random(10000, 30000)
			if (self.inverted) then
				self.trans_start = math.abs(self.current - 360) * -1 
			else
				self.trans_start = self.current
			end
			self.trans_delta = 0.03
			self.intro = true
			self.inverted = not self.inverted
			self.invert_count = 0
		end
		if (self.periodic_invert and self.inverted and not self.intro) then
			self.desired = 360 - self.desired
		elseif (self.inverted and self.intro) then
			self.desired = self.desired * -1
		end
		self.invert_count = self.invert_count + 1

		if (self.intro) then return nil else return(self.desired) end
	end
	
	function fov:cubic_interp(s, e, x)
		return( 2*(s-e)*x^3 - 3*(s-e)*x^2 + s)
	end
	
	function fov:smooth_trans()
		self.tmp = self.tmp + self.trans_delta
		self.current = self:cubic_interp(self.trans_start, self.desired, self.tmp)
		if (self.current < 0) then self.current = 360 + self.current end
		gkinterface.SetFOV(self.current)
		if self.tmp >= 1 then
			self.tmp = 0
			self.intro = false
		end
	end
	
	function fov:toggle_invert()
		self.periodic_invert = not self.periodic_invert
	end
		
	function fov:action()
		if self.intro then
			self:smooth_trans()
		else
			if (self:update_val()) then gkinterface.SetFOV(self.desired) end
		end
	end
	
	function fov:enable_cb()
		self.intro = true
		self.tmp = 0
		self:update_val()
	end
	
	function fov:disable_cb()
		gkinterface.SetFOV(self.orig)
	end
	
	return fov
end

lsd.add_module(lsd.get_module_fov())
